﻿using System;
using System.Threading.Tasks;
using Microsoft.Bot.Builder.Dialogs;
using Microsoft.Bot.Builder.Luis;
using Microsoft.Bot.Builder.Luis.Models;
using Microsoft.Bot.Connector;
using EmotionalNewsBot.Models;
using System.Collections.Generic;
using System.Net.Http;
using Newtonsoft.Json;
using System.Text;

namespace LuisBot.Dialogs
{
    [Serializable]
    //ToDo: Add your Luis App Id & Subscription key, or uncomment the code below to use the pre-built Luis model. 
    //[LuisModel("90248cbc-723c-425c-9789-8e6c6e5ecfa5", "b92a6603cabe45989d8eda44a817d01b")]
    [LuisModel("YourLuisId", "YourLuisSubscriptionKey")]
    public class RootDialog : LuisDialog<object>
    {
        [LuisIntent("")]
        [LuisIntent("None")]
        public async Task None(IDialogContext context, LuisResult result)
        {
            string response = $"Sorry, I did not understand '{result.Query}'. Type 'help' if you need assistance.";
            await context.PostAsync(response);
            context.Wait(this.MessageReceived);
        }

        [LuisIntent("News")]
        public async Task Search(IDialogContext context, IAwaitable<IMessageActivity> activity, LuisResult result)
        {
            string response = "I understand you want to search for news, but you have not taught me this skill yet."; 
            response += "Implement the Search task in RootDialog.cs to teach me how to do this and many other cool things!";
            await context.PostAsync(response);
            context.Wait(this.MessageReceived);
        }

        [LuisIntent("Help")]
        public async Task Help(IDialogContext context, LuisResult result)
        {
            string response = "I can help you find the freshest news articles \U0001F4F0 around the world, ";
            response += "and give you a hint about each article's sentiment based on its description. ";
            response += "Here are a few things you can try: \n\n-\n";
            response += "* find good news about microsoft\r"; 
            response += "* show me bad news about global warming\r";
            response += "* positive press about the elections\n-\n";
            response += "Tip: if I don't find exactly what you're looking for, try re-training my LUIS model";
            await context.PostAsync(response);               
            context.Wait(this.MessageReceived);
        }
    }
}